using Sandbox;
using Sandbox.UI;
using Sandbox.UI.Construct;
using System;
using System.Reflection;
using System.IO;
using System.Threading.Tasks;

public struct Walker{

	public readonly string name, description;
	public BasePlayerController controller;

	public Walker(string name, BasePlayerController c, string desc){
		this.name = name;
		controller = c;
		description = desc;
	}
}

public class Selector : Panel{
	Panel p;
	Label desc;
	bool meniout = false;
	Label label;
	void AddChildren(PanelEvent e){
		var meni = p;
		if(meniout)
			return;
		meniout = true;
		var c = p.Children.GetEnumerator();
		c.MoveNext(); c.MoveNext();
		while(c.MoveNext()){
			c.Current.Delete();
		}
		for ( int i = 0; i < MinimalGame.Walkers.Length;  ++i){
			var l = meni.Add.Button( MinimalGame.Walkers[i].name, "font" );
			l.UserData = i;
			l.AddEventListener("onclick", choose);
		}
	}

	void choose(PanelEvent e){
		Panel b = e.Target;
		while(b.UserData == null) b = b.Parent;
		int number = (int)(b.UserData);
		label.Text = MinimalGame.Walkers[number].name;
		var c = p.Children.GetEnumerator();
		c.MoveNext(); c.MoveNext();
		while(c.MoveNext()){
			c.Current.Delete();
		}
		meniout = false;
		desc.Text = MinimalGame.Walkers[number].description;
		MinimalGame.changewalk( number );
		VektorH.scale = 1;		

	}
	public Selector(){

		this.AddClass( "back" );
		p = new Panel( this, "menu" );
		label = p.Add.Label( "press tab for mouse", "font" );
		p.Add.Button( "⬇️", "dropdown").AddEventListener("onclick", AddChildren);

		desc = Add.Label("", "font2");


	}

	public override void Tick()
	{
		base.Tick();
		if(Input.Down(InputButton.Score)){
			desc.AddClass( "show" );
		}
		if(Input.Released(InputButton.Score)){
			desc.RemoveClass( "show" );
		}
	}
}

public class Health : Panel{
	Label label;
	public Health(){
			var p = new Panel(this);
			p.SetProperty( "style", "position: absolute; height: 60px; width: 130px; left: 0px; bottom: 0px; justify-content: center;" );
			label = p.Add.Label( "100" );
			label.SetProperty( "style", "font-size: 32px; color: orange; font-family:'Gill Sans';" );

	}
	public override void Tick(){
		base.Tick();
		var player = Local.Pawn;
		if(player != null)
			label.Text = "HP: " + (int)player.Health;
	}
}

public partial class HUD : Sandbox.HudEntity<RootPanel>
{
	
	public HUD()
	{
		if ( IsClient )
		{
			RootPanel.SetTemplate( "/HUD.html" );
			RootPanel.AddChild( new Health() );
		}
		if(IsServer){
			
		}

	}

}
public class MovementHUD : Sandbox.HudEntity<RootPanel>{
	public MovementHUD()
	{
		if ( IsClient )
		{
			RootPanel.SetTemplate( "/selector.html" );
			RootPanel.StyleSheet.Load( "/selector.scss" );
			RootPanel.AddChild<Selector>();
		}
	}
}
public partial class VektoriHUD : Sandbox.HudEntity<RootPanel>{
	public  static VektorH[] vektori = new VektorH[3];

	public static Label l;
	Panel krug;
	public VektorH DodajVektor(string color = "black", float duzina = 100){
			var ret = krug.AddChild<VektorH>();
			ret.color = color;
			ret.duzina = duzina;
			return ret;
	}
	public VektoriHUD(){

			for ( int i = 0; i < 3; ++i){
			vektori[i] = null;
		}
		
		if (IsClient)
		{
			RootPanel.StyleSheet.Load( "/vektori.scss" );
			krug = new Panel(RootPanel, "background");

			string[] boje = { "white" };


			for ( int i = 0; i < 1; ++i){
				var vek = DodajVektor(boje[i]);
				vektori[i] = vek;
			}
			VektorH.scale = 0.5f;

			l = new Label();
			l.SetProperty( "style", "font-size: 30px; color: white; font-family:'Gill Sans'; position: absolute; right: 10px; top: 200px;" );
			RootPanel.AddChild( l );

	

		}

	}

}

public class VektorH : Panel
{
	static public float scale=1;

	private string _color;
	private float _duzina;
	private float _ugao;

	public string color{ 
		get { return _color; } 
		set{
			_color = value; 
			this.Style.BackgroundColor = color;
			this.Style.Dirty();
		}
	}

	public float ugao{ get { return _ugao; } set
		{
			_ugao = value; 
			this.SetProperty( "style", $"transform: rotate({-_ugao}deg);" );
			this.Style.Dirty();
		}
	}

		public float duzina{ get { return _duzina; } set
		{
			_duzina = value;
			this.Style.Width = _duzina * scale;
			this.Style.Dirty();
		}
	}


	public VektorH(){
		this.AddClass( "vektor" );
	}

	public override void Tick()
	{
		base.Tick();
		var player = Local.Pawn;
		if(player != null){
			ugao = player.Velocity.DajUgao();
			duzina = player.Velocity.DajDistance() * 10;
			VektoriHUD.l.Text = (int)player.Velocity.x + ", " + (int)player.Velocity.y + ", " + (int)player.Velocity.z;
			if(duzina * scale > 100) scale *= 0.9f;
			//if((duzina * scale) > 0.5f && (duzina*scale) <2) scale *= 1.1f;
		}

	}

}


partial class MyPlayer : Player
{

	public void dobro()
	{
		if ( IsServer )
		{
			Controller = new noclip();
			this.Health = 10;
			Log.Info( "dfa" );
			Respawn();
		}
	}

	public MyPlayer()
	{

	}
	public override void Respawn()
	{
		SetModel( "models/citizen/citizen.vmdl" );

		// Use WalkController for movement (you can make your own PlayerController for 100% control)
		Controller = new WalkController();

		// Use StandardPlayerAnimator  (you can make your own PlayerAnimator for 100% control)
		Animator = new StandardPlayerAnimator();



		// Use ThirdPersonCamera (you can make your own Camera for 100% control)
		Camera = new FirstPersonCamera();

		EnableAllCollisions = true;
		EnableDrawing = true;
		EnableHideInFirstPerson = true;
		EnableShadowInFirstPerson = true;

		base.Respawn();

	}
}




public partial class MinimalGame : Sandbox.Game
	{

	public static Walker[] Walkers = new Walker[4]{
		new Walker("default", new WalkController(), "The default controller. Gets smooth motion by calling accelerate function. For some reason you walk faster while strafing a wall than just normally walking in a direction"),
		new Walker("Friction based movement", new WalkControllerForce(), "Walking based on friction. You continualy gain speed by walking but friction increases with speed and therefore you can only gain finite amount of speed. Its probably harder to run than a default controller but it is a bit more realistic. Walking on slopes affects your speed, no air controll, you can get fall damage from hitting the wall as well as water..."),
		new Walker("Noclip", new noclip(), "Just flying"),
		new Walker("Point and click", new PointAndClick(), "You travel to a position by pressing attack1")
};

public MinimalGame(){
			if ( IsServer )
			{

			Log.Info( "My Gamemode Has Created Serverside!" );

			// Create a HUD entity. This entity is globally networked
			// and when it is created clientside it creates the actual
			// UI panels. You don't have to create your HUD via an entity,
			// this just feels like a nice neat way to do it.

			new MovementHUD();
			new HUD();
			new VektoriHUD();


		}
		}


	public override void ClientJoined( Client client )
		{
			base.ClientJoined( client );


		var a = new MyPlayer();
		client.Pawn = a;
		a.Respawn();
		}

	[ServerCmd( "changewalk" )]
	public static void changewalk( int b)
	{
		var caller = ConsoleSystem.Caller;
		((MyPlayer)caller.Pawn).Controller = Walkers[b].controller;
	}
}



public static class dodatak{
	public static float DajUgao(this Vector3 v){
		float ugao = MathF.Atan(v.y / v.x) * (180/3.14159f);
		
		ugao += (v.x < 0 && v.y < 0) ? 180 : 0;
		ugao += (v.x < 0 && v.y >= 0) ? 180 : 0;
		return ugao;
	}

	public static float DajDistance(this Vector3 v){
		return MathF.Sqrt(v.x * v.x + v.y * v.y);
	}
}


